; =========================================================               
; CSXINPUT.INC: This file contains the includes needed for the
; Atari DSP implementation of CSX Synthesis. It should be
; included in each DAS file needed. This file contains those
; Addresses that must be known to the 68K code and the DSP only.
; =========================================================
; Copyright, 1995 Atari Corporation.
; Written for Atari by Highlight Software Solutions.
; =========================================================
; Apr 1996 HMK		Made changes for FameFilm. Moved
;			some variables into DSP RAM.
; =========================================================


.DATA
.QPHRASE
	CSXINSIZE       .EQU            1024     ; size in 16 bit words
						; of the input audio buffer.
	CSXINHSIZE	.EQU		(CSXINSIZE/2)
						; 1/2 way pt of buffer
						; used to start any new
						; sound track
;       Input Audio Buffer Definition

.if 0  ; *** HMK 6/22/96 take it out because we don't use CSXIN_START buffer
       ; *** we need to save space 
CSXIN_START::
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	; 256 bytes

	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	; 512 bytes

	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	; 768 bytes

	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	; 1K bytes
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	; 256 bytes

	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	; 512 bytes

	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	; 768 bytes

	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	; 2K bytes
.endif

; 68K Debug Registers
; -------------------
CSX68_1::
	dc.l	0
CSX68_2::
	dc.l	0
CSX68_3::
	dc.l	0
CSX68_4::
	dc.l	0







