;******************************************************************************
;            (C) Copyright 1992-1995, Radius, Inc. and Atari Corp.
; Secret and confidential                                   All rights reserved
;******************************************************************************
; This source code and any compilation or derivative thereof is the joint
; property of Radius, Inc. and Atari Corp.  This code is provided pursuant
; to a Software License Agreement and/or Software Development Contract.  This
; code is the proprietary information of Radius, Inc. and Atari Corp. and is
; confidential in nature.  Its use and dissemination by any party other than
; Atari Corp. are strictly limited by the confidential information provisions
; of the Agreement or Contract referenced above.
;******************************************************************************
; 100 20 Jul 95 JPE     Initial revision (formerly part of player.s). Playlist
;                       hand-tailored for 10JUL95C and 11JUL95B disks.
; 101 15 Sep 95 JPE     List structure modified from linear to tree format.
; 102 05 Oct 95 JPE     Alternate subtitle keys added. Pseudo "ROM" storage
;                       area added. Eliminated pseudo track numbers (-2).
;                       Added node-completion and profile incremental scores.
; 103 20 Oct 95 JPE     Added NODE tags for jump-ahead in memory jog. Added
;                       END_PATH tags. Eliminated storage for buffer control.
;                       Added node ID's.
; 104 08 Nov 95 JPE     Removed score and profile increments.
; 105 05 Dec 95 JPE     Removed bogus path endings used by loader. Eliminated
;                       storage for undoctored version. Converted to component
;                       list representation. Single credits track used at end.
; 106 02 Feb 96 JPE     Reduced film attribute size to 16 bits. Added history
;                       field. Eliminated backward links except for fan-in.
;                       Added SKIP and RATED entries. Eliminated SNGL_LEAD,
;                       SUSPEND and PASS_ZERO hacks. Added CENSOR, RELAY,
;                       COUNT, SWITCH and BURN control elements. Added HYPER
;                       film type. Added leadouts. Added DEMO hacks.
; 107 14 Feb 96 JPE     Shell structure incorporates output from "mktree".
;                       Eliminated node list. Added canned paths for VCR mode.
;******************************************************************************

        .nlist
        .include    'player.inc'
        .include    'params.inc'
        .include    'caves_1.inc'
        .list

;==============================================================================
;                               Playlist
;==============================================================================

playList::

        .include    'caves_1.s'

playListEnd::

;------ Entry point -----------------------------------------------------------

playListEnt::

.if CD
;        dc.l    JP_START
        dc.l    LDI006
;;        dc.l    LDO006
.else
;;        dc.l    LDO006
        dc.l    LDI006
.endif

;------ Canned paths for VCR mode ---------------------------------------------

movie1Path::
movie2Path::

        dc.w    MLDI08B - LOOP0007      ; Loop 7: grab the nurse
        dc.w    LDI009 - LOOP0014       ; Loop 14: default
        dc.w    LDI006 - COUNT911       ; Count 0911: wake up
        dc.w    MLDI08B - LOOP0007      ; Loop 7: grab the nurse
        dc.w    LDI018 - LOOP0014       ; Loop 14: enough
        dc.w    MLDI22B - LOOP0021      ; Loop 21: bust loose
        dc.w    MLDI22A - HYPER2324     ; Hyper 2324: visit doctor

