//
// -----------------
// Splash Screen DLL
// -----------------
//	Provides a method for the GameFilm engine and CD-Autorun programs to
//	share bitmap resources. To save space, the bitmaps are stored as
//	compressed resources, with a special DLL function provided to
//	decompress the data, set up a DIB from the data (as a DIBSECTION)
//	and return an HBITMAP for that DIB.
//
//	Author: Jack Thornton
//	for CetaSoft / Level Five, Inc.
//	952 Postal Way, Suite 3
//	Vista, CA 92083
//	(619) 631-5855
//
//	Client: Atari Corporation
//	Project: GameFilm Engine
//	Date: 2/24/96
// --------------------------------------------------------------------------

#ifndef _SPLSHDLL_H
#define _SPLSHDLL_H

#ifdef __cplusplus
extern "C" {            /* Assume C declarations for C++ */
#endif

// Prototypes for the DLL-provided access functions
BOOL FetchBitmap(UINT index, LPBITMAPINFO *pHdr, LPVOID *pBits, RECT *pDestRect);
void DiscardBitmap(UINT index);

// Indices for bitmaps
#define PIC_SPLASH_SCREEN	0
#define PIC_BTNPLAY_NORMAL	1
#define PIC_BTNPLAY_HILITE	2
#define PIC_BTNPLAY_PUSHED	3
#define PIC_BTNOPTIONS_NORMAL	4
#define PIC_BTNOPTIONS_HILITE	5
#define PIC_BTNOPTIONS_PUSHED	6
#define PIC_BTNEXIT_NORMAL	7
#define PIC_BTNEXIT_HILITE	8
#define PIC_BTNEXIT_PUSHED	9
#define PIC_BTNINSTALL_NORMAL	10
#define PIC_BTNINSTALL_HILITE	11
#define PIC_BTNINSTALL_PUSHED	12
#define PIC_BTNCANCEL_NORMAL	13
#define PIC_BTNCANCEL_HILITE	14
#define PIC_BTNCANCEL_PUSHED	15

#ifdef __cplusplus
}
#endif

#endif	// _SPLSHDLL_H

