/********************************************************************\
	Sample Reader
	by Rudy Mathieu
\********************************************************************/

#include <windows.h>
#include <assert.h>
#include "SReader.h"
#include "dbgtst.h"

long RAVSampleReader::_Read(void)
{
  long	bytes;
  PBYTE	ptr;

  if (readStatus==0)
  {
    // Read Sample Header
    bytes=buffer->Read(sampleptr,sizeof(*sampleptr));
    if (bytes < 0)
      return bytes;
    if (bytes==0)
    {
      DebugString("Only read %d bytes\n", bytes);
    }

    readStatus++;
  }

  if (readStatus==1)
  {
    // Read video sample
    ptr = (PBYTE) sizeof(*sampleptr);
    sampleptr->video = ptr; // Video data pointer
    bytes = buffer->Read((PBYTE)sampleptr + (UINT)ptr,sampleptr->videoSize);
    if (bytes < (long)sampleptr->videoSize)
    {
      if (bytes < 1)
        return bytes;
      else
        return SAMPLE_READ_ERROR;
    }
    readStatus++;
  }

  if (readStatus==2)
  {
    // Read Audio smaple
    ptr = (PBYTE) (sampleptr->videoSize + sizeof(*sampleptr));
    sampleptr->audio = ptr;
    bytes = buffer->Read((PBYTE)sampleptr + (UINT)ptr,sampleptr->audioSize);
    if (bytes < (long)sampleptr->audioSize)
    {
      if (bytes < 1)
        return bytes;
      else
        return SAMPLE_READ_ERROR;
    }
    readStatus++;
  }

  if (readStatus==3)
  {
    char pad[4];
    UINT p1 = (sampleptr->videoSize + sampleptr->audioSize);

    UINT padsize = 4 - (p1 & 3);
    if (padsize==4)
      padsize = 0;

    bytes = buffer->Read(pad,padsize);
    if (bytes < (long)padsize)
    {
      if (bytes < 0)
        return bytes;
      else
        return SAMPLE_READ_ERROR;
    }
    readStatus=0;
    return 0;
  }

  return SAMPLE_READ_ERROR;
}

void	__fastcall RAVSampleReader::Link(int id) 
{
  buffer=shandle->Data(id); 
  shandleid = id;
  readStatus = 0;
}

void __fastcall RAVSampleReader::Link(SmartGroup *g) 
{
  shandle = g; 
}
long __fastcall RAVSampleReader::ReadHeader(FileInfoStr* header)
{
  return buffer->Read(header, sizeof(*header));
}

long __fastcall RAVSampleReader::ReallyReadHeader(FileInfoStr* header)
{
  if (ReadHeader(header) != sizeof(*header))
  {
    // Ensure header is available.
    shandle->Data(shandleid)->SpotCheck(2<<10);
    if (ReadHeader(header) != sizeof(*header))
    {
      return -2;
    }
  }
  readStatus = 0;
  return sizeof(*header);
}
