
#include "precomp.h"
#pragma hdrstop
#include "testread.h"

#define CREATE(x)   new CreateFile_File(x)

// -------------------------------------------------------------- DECLARATIONS
#define MSG_DOTEST  (WM_USER+1234)

// ----------------------------------------------------------------- VARIABLES
char *filelist[] = {
    "BCKR__MA.RAV",
    "BDY09_NA.RAV",
    "BDY12_OA.RAV",
    "BDY15_PA.RAV",
    "BDY16_QA.RAV",
    "BDY18_RA.RAV",
    "BDY23_SA.RAV",
    "BDY25_TA.RAV",
    "BDY_2_UA.RAV",
    "BDY_6_VA.RAV",
    "BRNBC_WA.RAV",
    "BTJCK_XA.RAV",
    "DWNST_YA.RAV",
    "END1C_ZA.RAV",
    "END2C_3A.RAV",
    "END3C_4A.RAV",
    "END4C_5A.RAV",
    "END5C_6A.RAV",
    "END6C_7A.RAV",
    "END7C_8A.RAV",
    "END8C_AB.RAV",
    "END9C_BB.RAV",
    "ENTR__CB.RAV",
    "GN_DR_DB.RAV",
    "LDN01_EB.RAV",
    "LDN02_FB.RAV",
    "LDN15_GB.RAV",
    "LDN18_HB.RAV",
    "LDN22_IB.RAV",
    "LDN_6_JB.RAV",
    "LD_N__KB.RAV",
    "LEADI_LB.RAV",
    "LOOP7_MB.RAV",
    "LOP14_NB.RAV",
    "LOP21_OB.RAV",
    "TITLS_PB.RAV",
    NULL
};

char MainAppWinClassName[] = "CDTimingTests";

DWORD seekPositions[] = {
    73640,
    23480,
    204800,
    2048,
    4096000,
    40960,
    15000038,
    92160,
    10240000,
    187532,
    335876,
    1983372,
    3472188,
    8000000,
    123456,
    0
};
#define NUM_SEEK_POSITIONS 16

HINSTANCE hInstance;

char sourceDir[260];

char buffer[1025*1024];

// ---------------------------------------------------------------- PROTOTYPES

LRESULT CALLBACK MainAppWinProc(HWND, UINT, WPARAM, LPARAM);

// ---------------------------------------------------------------------- CODE
int PASCAL
WinMain(HINSTANCE hInst, HINSTANCE hPrev, LPSTR lpszCmdLine, int nCmdShow)
{
MSG msg;		// current message being processed
WNDCLASS info;		// window class structure

    hInstance = hInst;

    // fill out a structure for registering our window class
    info.style = CS_HREDRAW | CS_VREDRAW ;   // window redraws on resize
    info.lpfnWndProc = MainAppWinProc; // our message handler for the class
    info.cbClsExtra = 0;		// no extra class bytes
    info.cbWndExtra = 0;		// no extra window bytes
    info.hInstance = hInstance; 	// copied from global variable
    info.hIcon = (HICON)NULL;
    info.hCursor = LoadCursor(NULL, IDC_ARROW);   // use standard arrow cursor
    info.hbrBackground = (HBRUSH) (COLOR_APPWORKSPACE + 1);
    info.lpszMenuName = NULL;
    info.lpszClassName = MainAppWinClassName;	// name of the class

    // register the class as defined by our info structure
    if (!RegisterClass(&info))
	return FALSE;

    // create our main window (an instance of our defined window class)
    CreateWindow(
	MainAppWinClassName,
	"Running test... please wait",
	WS_OVERLAPPED | WS_CAPTION | WS_THICKFRAME |
	  WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX |
	  WS_CLIPCHILDREN | WS_CLIPSIBLINGS | WS_VISIBLE,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	350,
	40,
	HWND_DESKTOP,
	NULL,
	hInstance,
	NULL
	);

    // process the messages that come to our program
    while (GetMessage(&msg, NULL, 0, 0)) {
	TranslateMessage(&msg);
	DispatchMessage(&msg);
    }

    // return the exit code to Windows
    return msg.wParam;	    // the last message is always WM_QUIT
}

LRESULT CALLBACK
MainAppWinProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
int i;
StopWatch watch;
unsigned total;
FILE *logfile;
char msg[128];
char compositeName[260];
File *testFile;
OPENFILENAME of;

    // take the appropriate action for the type of message being sent
    switch (message) {
	case WM_CREATE:
	    PostMessage(hWnd, MSG_DOTEST, 0, 0);
	    break;

	case MSG_DOTEST:
	    // prioritize
	    SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_HIGHEST);

	    // open a logfile
	    logfile = fopen("D:\\timelog.txt", "wt");
	    if (!logfile) {
		MessageBox(hWnd, "Can't open logfile", "Fuck", MB_OK);
	    } else {
		// commit the buffer
		memset(buffer, 0, 1025*1024);
		memset(buffer, 0, 1025*1024);
		memset(buffer, 0, 1025*1024);

		// ask where the CD is
		sourceDir[0] = 0;
		of.lStructSize = sizeof(OPENFILENAME);
		of.hwndOwner = hWnd;
		of.hInstance = hInstance;
		of.lpstrFilter = NULL;
		of.lpstrCustomFilter = NULL;
		of.nMaxCustFilter = 0;
		of.nFilterIndex = 0;
		of.lpstrFile = sourceDir;
		of.nMaxFile = 260;
		of.lpstrFileTitle = NULL;
		of.nMaxFileTitle = 0;
		of.lpstrInitialDir = "D:\\";
		of.lpstrTitle = "Select RAV files directory";
		of.Flags = OFN_EXPLORER | OFN_LONGNAMES | OFN_NOVALIDATE;
		of.lpstrDefExt = NULL;
		GetOpenFileName(&of);

		// truncate at the directory name
		sourceDir[of.nFileOffset] = 0;

		// test open times
		fputs("-------- Just opening\n", logfile);
		for (i = 0; filelist[i]; i++) {
		    // create file object
		    wsprintf(compositeName, "%s%s", sourceDir, filelist[i]);
		    testFile = CREATE(compositeName);

		    // open file
		    wsprintf(msg, "Opening %s", filelist[i]);
		    watch.Start();
		    if (!testFile->Open()) {
			MessageBox(hWnd, testFile->GetErrorMessage(),
			    "Open File Error", MB_OK);
			delete testFile;
			goto bye;
		    }
		    watch.Stop(msg, logfile);

		    // dump file object
		    testFile->Close();
		    delete testFile;
		}

		// test open times
		fputs("-------- Open and read\n", logfile);
		for (i = 0; filelist[i]; i++) {
		    // create file object
		    wsprintf(compositeName, "%s%s", sourceDir, filelist[i]);
		    testFile = CREATE(compositeName);

		    // open file
		    wsprintf(msg, "Opening %s and reading 1 sector", filelist[i]);
		    watch.Start();
		    testFile->Open();
		    testFile->Read(buffer, 2048);
		    watch.Stop(msg, logfile);

		    // read sectors
		    watch.Start();
		    testFile->Read(buffer, 2048);
		    watch.Stop("Reading 2nd sector ", logfile);
		    watch.Start();
		    testFile->Read(buffer, 16384);
		    watch.Stop("Reading 16k bytes", logfile);
		    watch.Start();
		    testFile->Read(buffer, 32768);
		    watch.Stop("Reading 32k bytes", logfile);
		    watch.Start();
		    testFile->Read(buffer, 32768*4);
		    watch.Stop("Reading 128k bytes", logfile);

		    // close file
		    testFile->Close();
		    delete testFile;

		    // room between reports
		    fputs("\n", logfile);
		}

	    // test seek assumptions
		// open a file
		wsprintf(compositeName, "%s%s", sourceDir, filelist[8]);
		testFile = CREATE(filelist[8]);
		testFile->Open();

		// do some seeks
		fputs("-------- Just seeking, no reading\n", logfile);
		for (i = 0; i < NUM_SEEK_POSITIONS; i++) {
		    sprintf(msg, "Seeking to %-9u", seekPositions[i]);
		    watch.Start();
		    testFile->Seek(seekPositions[i], SEEK_SET);
		    watch.Stop(msg, logfile);
		}
		fputs("\n-------- Seeks followed by reads\n", logfile);
		for (i = 0; i < NUM_SEEK_POSITIONS; i++) {
		    sprintf(msg, "Reading 16k after seek to %-9u", seekPositions[i]);
		    watch.Start();
		    testFile->Seek(seekPositions[i], SEEK_SET);
		    testFile->Read(buffer, 16384);
		    watch.Stop(msg, logfile);
		}
		fputs("\n-------- Lots of reading\n", logfile);
		testFile->Seek(0, SEEK_SET);

		total = 0;
		for (i = 0; i < 8; i++) {
		    watch.Start();
		    testFile->Read(buffer, 1024*1024);
		    total += watch.Stop("Reading 1M", logfile);
		}
		fprintf(logfile, "---- Average %u ms; %g/k\n", total / 8,
		    ((double)total * 1000.) / (8. * 1024. * 1024.));

		total = 0;
		for (i = 0; i < 32; i++) {
		    watch.Start();
		    testFile->Read(buffer, 2048);
		    total += watch.Stop("Reading 2K", logfile);
		}
		fprintf(logfile, "---- Average %u ms; %g ms/k\n", total / 32,
		    ((double)total * 1000.) / (2. * 32. * 1024.));

		total = 0;
		for (i = 0; i < 32; i++) {
		    watch.Start();
		    testFile->Read(buffer, 4096);
		    total += watch.Stop("Reading 4K", logfile);
		}
		fprintf(logfile, "---- Average %u ms; %g ms/k\n", total / 32,
		    ((double)total * 1000.) / (4. * 32. * 1024.));

		total = 0;
		for (i = 0; i < 32; i++) {
		    watch.Start();
		    testFile->Read(buffer, 8192);
		    total += watch.Stop("Reading 8K", logfile);
		}
		fprintf(logfile, "---- Average %u ms; %g ms/k\n", total / 32,
		    ((double)total * 1000.) / (8. * 32. * 1024.));

		total = 0;
		for (i = 0; i < 32; i++) {
		    watch.Start();
		    testFile->Read(buffer, 16384);
		    total += watch.Stop("Reading 16K", logfile);
		}
		fprintf(logfile, "---- Average %u ms; %g ms/k\n", total / 32,
		    ((double)total * 1000.) / (16. * 32. * 1024.));

		// close the test seeker
		testFile->Close();
		delete testFile;

		// close the logfile
		fclose(logfile);
	    }

	    // close the window
bye:	    DestroyWindow(hWnd);
	    break;

	case WM_DESTROY:
	    // we are outa here!
	    PostQuitMessage(0);
	    break;
    }

    // any message we don't handle (and some we do) gets passed to default proc
    return DefWindowProc(hWnd, message, wParam, lParam);
}

//
// -------------------------------------------------------- FILE CLASS METHODS
//

File::File(char *file)
{
    // copy filename into member variable
    lstrcpy(filename, file);
    errorCode = 0;
    errorMessage[0] = 0;
}

File::~File()
{
}

unsigned
File::GetErrorCode(void)
{
    return errorCode;
}

LPSTR
File::GetErrorMessage(void)
{
    return (LPSTR) errorMessage;
}

// ****************

CreateFile_File::CreateFile_File(char *filename) : File(filename)
{
}

CreateFile_File::~CreateFile_File()
{
    if (isOpen)
	Close();
}

void
CreateFile_File::researchError()
{
    errorCode = GetLastError();
    FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,
		  0,
		  errorCode,
		  0,
		  errorMessage,
		  255,
		  0);
}

BOOL
CreateFile_File::Open(void)
{
    security.nLength = sizeof(SECURITY_ATTRIBUTES);
    security.lpSecurityDescriptor = 0;
    security.bInheritHandle = FALSE;
    hFile = CreateFile(filename,
		       GENERIC_READ,
		       FILE_SHARE_READ,
		       &security,
		       OPEN_EXISTING,
		       FILE_FLAG_NO_BUFFERING
			  | FILE_FLAG_WRITE_THROUGH
			  | FILE_FLAG_SEQUENTIAL_SCAN,
		       NULL
		       );
    if (hFile == INVALID_HANDLE_VALUE) {
	researchError();
	isOpen = FALSE;
	return FALSE;
    } else
	isOpen = TRUE;

    return TRUE;
}

BOOL
CreateFile_File::Read(void *buffer, unsigned length)
{
DWORD bytesRead;

    ReadFile(hFile, buffer, length, &bytesRead, NULL);
    if (length != bytesRead) {
	researchError();
	return FALSE;
    }

    return TRUE;
}

BOOL
CreateFile_File::Write(void *buffer, unsigned length)
{
DWORD bytesWritten;

    ReadFile(hFile, buffer, length, &bytesWritten, NULL);
    if (length != bytesWritten) {
	researchError();
	return FALSE;
    }

    return TRUE;
}

BOOL
CreateFile_File::Seek(long position, int fromWhere)
{
unsigned retval;

#if (SEEK_SET != FILE_BEGIN) || (SEEK_CUR != FILE_CURRENT) || (SEEK_END != FILE_END)
    switch (fromWhere) {
	case SEEK_SET:
	    fromWhere = FILE_BEGIN;
	    break;

	case SEEK_CUR:
	    fromWhere = FILE_CURRENT;
	    break;

	case SEEK_END:
	    fromWhere = FILE_END;
	    break;

	default:
	    return FALSE;
    }
#endif

    retval = SetFilePointer(hFile, position, NULL, fromWhere);
    if (retval == 0xffffffff) {
	researchError();
	return FALSE;
    }

    return TRUE;
}

long
CreateFile_File::Tell(void)
{
unsigned retval;

    retval = SetFilePointer(hFile, 0, NULL, FILE_CURRENT);
    if (retval == 0xffffffff)
	researchError();

    return retval;
}

void
CreateFile_File::Close(void)
{
    if (isOpen) {
	CloseHandle(hFile);
	hFile = INVALID_HANDLE_VALUE;
	isOpen = FALSE;
    }
}

// ****************

MMIO_File::MMIO_File(char *filename) : File(filename)
{
}

MMIO_File::~MMIO_File()
{
    if (isOpen)
	Close();
}

BOOL
MMIO_File::Open(void)
{
    if ((hFile = mmioOpen(filename, &fInfo, MMIO_READ | MMIO_ALLOCBUF)) == 0) {
	researchError();
	return FALSE;
    }
    mmioGetInfo(hFile, &fInfo, 0);
    return TRUE;
}

BOOL
MMIO_File::Read(void *buffer, unsigned length)
{
MMRESULT result;

    // point the disk-load buffer directly to the indicated buffer
    mmioSetBuffer(hFile, (char *)buffer, length, 0);

    // now, load by getting info and "advancing" the file read
    mmioGetInfo(hFile, &fInfo, 0);
    result = mmioAdvance(hFile, &fInfo, MMIO_READ);
    return result == MMSYSERR_NOERROR;
}

BOOL
MMIO_File::Write(void *buffer, unsigned length)
{
MMRESULT result;

    // point the disk-load buffer directly to the indicated buffer
    mmioSetBuffer(hFile, (char *)buffer, length, 0);

    // now, load by getting info and "advancing" the file read
    mmioGetInfo(hFile, &fInfo, 0);
    fInfo.dwFlags |= MMIO_DIRTY;
    result = mmioAdvance(hFile, &fInfo, MMIO_WRITE);
    return result == MMSYSERR_NOERROR;
}

BOOL
MMIO_File::Seek(long position, int fromWhere)
{
    mmioSeek(hFile, position, fromWhere);
    return TRUE;
}

long
MMIO_File::Tell(void)
{
    mmioGetInfo(hFile, &fInfo, 0);
    return fInfo.lDiskOffset;
}

void
MMIO_File::Close(void)
{
    if (isOpen) {
	mmioClose(hFile, 0);
	hFile = NULL;
	isOpen = FALSE;
    }
}

void
MMIO_File::researchError(void)
{
    lstrcpy(errorMessage, "Error system still under construction");
    errorCode = 0xffffffff;
}

//
// --------------------------------------------------------- STOPWATCH METHODS
//

StopWatch::StopWatch()
{
}

StopWatch::~StopWatch()
{
}

void
StopWatch::Start()
{
    startMS = timeGetTime();
}

unsigned
StopWatch::Stop(char *prefixMsg, FILE *outfd)
{
char msgbuf[1024];
unsigned deltaMS;

    deltaMS = timeGetTime() - startMS;
    wsprintf(msgbuf, "%s: elapsed time %u ms\n", prefixMsg, deltaMS);
    fputs(msgbuf, outfd);
    return deltaMS;
}

