
#ifndef _TESTREAD_H
#define _TESTREAD_H

class File {
  public:
    File(char *filename);
    virtual ~File();

    virtual BOOL Open(void) = 0;
    virtual BOOL Read(void *buffer, unsigned length) = 0;
    virtual BOOL Write(void *buffer, unsigned length) = 0;
    virtual BOOL Seek(long position, int fromWhere) = 0;
    virtual long Tell(void) = 0;
    virtual void Close(void) = 0;
    unsigned GetErrorCode(void);
    LPSTR GetErrorMessage(void);

  protected:
    char filename[256];
    char errorMessage[256];
    unsigned errorCode;
    BOOL isOpen;
};

class CreateFile_File : public File {
  public:
    CreateFile_File(char *filename);
    ~CreateFile_File();

    BOOL Open(void);
    BOOL Read(void *buffer, unsigned length);
    BOOL Write(void *buffer, unsigned length);
    BOOL Seek(long position, int fromWhere);
    long Tell(void);
    void Close(void);

  private:
    HANDLE hFile;
    SECURITY_ATTRIBUTES security;
    void researchError(void);
};

class MMIO_File : public File {
  public:
    MMIO_File(char *filename);
    ~MMIO_File();

    BOOL Open(void);
    BOOL Read(void *buffer, unsigned length);
    BOOL Write(void *buffer, unsigned length);
    BOOL Seek(long position, int fromWhere);
    long Tell(void);
    void Close(void);

  private:
    HMMIO hFile;	    // handle to open asset file
    MMIOINFO fInfo;	    // file information
    void researchError(void);
};

class StopWatch {
  public:
    StopWatch();

    void Start();
    unsigned Stop(char *prefixMessage, FILE *outfd);

  private:
    unsigned startMS;
};

#endif

