#ifndef __CSTRING_H
#define __CSTRING_H
#include <string.h>
#include <malloc.h>
class string
{
  public:
    string()
      : data(0)
    {
    }
    string(const char* d)
      : data(d?strdup(d):0)
    {
    }
    string(const string& other)
    {
      if (other.data)
      {
        data = strdup(other.data);
      }
      else
      {
        data = 0;
      }
    }
    string& operator+=(const string& other)
    {
      Append(other);
      return *this;
    }
    void Append(const string& other)
    {
      int k1 = data?strlen(data):0;
      int k2 = other.data?strlen(other.data):0;
      if (k2) // else nothing to do!
      {
        char* newdata = (char*)malloc(k1+k2+1);
        if (k1) memcpy(newdata, data, k1);
        memcpy(newdata+k1, other.data, k2);
        *(newdata+k1+k2)=0;
        free(data);
        data = newdata;
      }
    }
    void Copy(const string& other)
    {
      if (this != &other)
      {
        if (data) free(data);
        if (other.data)
        {
          data = strdup(other.data);
        }
        else
        {
          data = 0;
        }
      }
    }
    string& operator=(const string& other)
    {
      Copy(other);
      return *this;
    }
    virtual ~string()
    {
      if (data) free(data);
    }
    char* c_str()
    {
      return data;
    }
    const char* c_str() const
    {
      return data;
    }
    int operator==(const string& other) const
    {
      return (strcmp(data, other.data)==0);
    }
    int operator<(const string& other) const
    {
      return (strcmp(data, other.data)<0);
    }
    int operator!=(const string& other) const
    {
      return (strcmp(data, other.data)!=0);
    }
	int length() const
	{
	  return strlen(data);
	}
   void resize(unsigned nsize)
   {
     data = (char*)realloc(data, nsize+1);
   }
  private:
    char* data;
};
inline string operator+(const string& a, const string& b)
{
  string r = a;
  r.Append(b);
  return r;
}
#endif
