/***************************************************************************\
					Debug and Testing Functioins
\***************************************************************************/

#include <windows.h>
#include <stdio.h>
#include "dbgtst.h"

static char buffer[256];

#ifdef DEBUG_MODE_ON

void WindowString(HWND hWnd,char *text, ... )
{
    va_list         vlist;
    va_start( vlist, text );
    vsprintf( buffer, text, vlist );
    va_end( vlist );
	SetWindowText(hWnd,buffer);
}

void DebugString(char *text, ... )
{
    va_list         vlist;
    va_start( vlist, text );
    vsprintf( buffer, text, vlist );
    va_end( vlist );
	OutputDebugString(buffer);
}

void MessageBox_OK(HWND win, char *title, char *text, ...)
{
    va_list         vlist;
    va_start( vlist, text );
    vsprintf( buffer, text, vlist );
    va_end( vlist );
	
	MessageBox(win,buffer,title,MB_ICONSTOP|MB_OK);
}

#else

// This is a sad way of not implementing the these functions
// but with the variable arguments passed, what are we to do!
// Remember to pull references to these functions from code 
// in final.

void WindowString(HWND hWnd,char *text, ... )
{
	return;
}

void DebugString(char *text, ... )
{
	return;
}

void MessageBox_OK(HWND win, char *title, char *text, ...)
{
	return;
}

#endif

DWORD DebugDataRate(HWND hWnd, int amount)
{
	static DWORD framenumber=0;
	static DWORD time1=0;
	DWORD time2=GetTickCount();
	framenumber += amount;
	if (time2 - time1 > 1000)
	{
		DWORD fr=framenumber;
		sprintf(buffer,"ATARI's Gamefilm [Rate : %u]\0",framenumber);
		SetWindowText(hWnd,buffer);
		time1=time2;
		framenumber=0;
		return fr;
	}
	return 0;
}