/****************************************************\
	DIB for video scatch pad.
	This intermediate buffer handles all GDI graphic
	data before transfering to a frame buffer.

	This class is designed to work using 16 BPP Only
\****************************************************/
#ifndef _WINDIBHEADER
#define _WINDIBHEADER
#include "mem.h"

#define FADER_DIBBITDEPTH	 16

#if FADER_DIBBITDEPTH == 24
#define FADEMAX		256
#else
#define FADEMAX		32
#endif

class FaderControl {
private:
	HDC 		DIBdc1;		// Device Context #1
	HDC 		DIBdc2;		// Device Context #2

	LPBYTE 		DIBBuffer1;	// Pointer to bitmap #1
	LPBYTE 		DIBBuffer2;	// Pointer to bitmap #2
	HBITMAP		hBitmap1;	// Handle to Bitmap #1
	HBITMAP		hBitmap2;	// Handle to Bitmap #2
	int			DIBWidth;	// Width of Area
	int			DIBHeight;	// Height of Area

	LPRECT	Print(char *str, HFONT hFont, COLORREF fcolor, COLORREF bcolor);

public:
		~FaderControl() { Close(); }
		FaderControl() 
		{ 
			DIBdc1 = DIBdc2 = NULL; 
			hBitmap1 = hBitmap2 = NULL; 
		}

	BOOL	Open(int width, int height);
	void	Close(void);
	
	//		This points to top DC only
	HDC		DC(void) { return DIBdc1; }

	// level is 0-Black  256-Opaque
	void	__fastcall UseFilter(int level, int zoom, HDC destDC);
};

#endif
