/********************************************************************\
	Function Timers Header
	by Rudy Mathieu
\********************************************************************/
#ifndef _FUNCTIMERSHEADER
#define _FUNCTIMERSHEADER

#include <windows.h>
#include "Sptypes.h"
#include "assert.h"

class PeriodicTimer {
private:
	DWORD				startTime;
	int					period;
	
	// Callback Funtion Data
	genericCallback		function;	// Function Name
	LPVOID				parameter;	// Calling parameter

public:
	PeriodicTimer();
	void __fastcall Set(int per, genericCallback fn, LPVOID param);
	BOOL __fastcall TimeElapsed() ;
};

	// Set Period, Function and Function Param
inline void __fastcall PeriodicTimer::Set(int per, genericCallback fn, LPVOID param) 
{ 
	function=fn; parameter=param; 
	period = per; startTime = GetTickCount();
}

// Check for time elapsed and reset if so 
inline BOOL __fastcall PeriodicTimer::TimeElapsed() 
{
	DWORD clockTickCount = GetTickCount();
	register BOOL retval = (long)(clockTickCount - startTime) > period;
	if (retval)	
	{
		startTime = clockTickCount;
		// assert(function != NULL); /* Make sure we have a function to run */
		if (function)
			(*function)(parameter); // Callback function
	}
	return retval;
}

inline PeriodicTimer::PeriodicTimer() 
{ 
	startTime = period = 0; function=NULL; 
}

#endif
