#ifndef __HISTOGRAM_H
#define __HISTOGRAM_H
#include <stdio.h>

class Histogram
{
public:
  enum { nbins=10};
  void Enter(unsigned value)
  {
    int bin = value*num/den;
    if (bin>nbins-1)
    {
      bin=nbins-1;
    }
    bins[bin]++;
  }
  void SetMulDiv(int mul, int div)
  {
    num = mul;
    den = div;
  }
  void Report(const char* title, const char* dev=(const char*)-1)
  {
    unsigned total = 0;
    unsigned average = 0;
    int i;
    for (i=0; i<nbins; i++)
    {
      total+=bins[i];
      average+=i*bins[i];
    }
    if (total==0) total=1;
    char buf[80];
    wsprintf(buf, "%s\r\n", title);
    Output(dev,buf);
    for (i=0; i<nbins; i++)
    {
      wsprintf(buf, "%d %u(%u%%)\r\n"
              , i*den/num
              , bins[i]
              , bins[i]*100/total
              );
      Output(dev,buf);
    }
    average = average*den/num;
    sprintf(buf, "avg: %f\r\n", average*1.0/total);
    Output(dev,buf);
  }
  void Clear()
  {
    memset(bins, 0, sizeof(bins));
  }
  Histogram()
  {
    num = 1;
    den = 1;
  }
private:
  void Output(const char* dev, const char* buf)
  {
    if (dev==0)
    {
      OutputDebugString(buf);
    }
  }
  unsigned bins[nbins];
  int num;
  int den;
};
#endif