#ifndef __PROPPAGE_H
#define __PROPPAGE_H
#include "basewin.h"
#include <prsht.h>
class CPropertySheet;
class CPropertyPage : public BaseWin
{
public:
  CPropertyPage(const char* tmpl, const char* title, const char* icon=0);
  CPropertyPage(const char* tmpl, const char* title, int icon);
  //CPropertyPage(const char* tmpl, const char* title, HICON icon);
  //CPropertyPage(int tmpl, const char* title, const char* icon=0);
  //CPropertyPage(int tmpl, const char* title, HICON icon);
  //CPropertyPage(DLGTEMPLATE* tmpl, const char* title, const char* icon=0);
  //CPropertyPage(DLGTEMPLATE* tmpl, const char* title, HICON icon);
  
  void Select(); // uses PSM_SETCURSEL via par to select this page.

  void EnableApply();
  void DisableApply();

  virtual BOOL OnKillActive(CPropertySheet* par) { return FALSE; }
  virtual int OnSetActive(CPropertySheet* par) { return 0; }
  virtual int OnApply(CPropertySheet* par) { return PSNRET_NOERROR; }
  virtual void OnHelp(CPropertySheet* par) {}
  virtual BOOL OnQueryCancel(CPropertySheet* par) { return FALSE; }
  virtual void OnReset(CPropertySheet* par) {}
private:
  int ExecuteNotify(int id, HWND h, int note);
  void Setup(const char* tmpl, const char* title, const char* icon);

  friend class CPropertySheet;
  PROPSHEETPAGE rep;
  CPropertySheet* par;

  static BOOL CALLBACK handler(HWND h, UINT msg, WPARAM,LPARAM);
}; 
#endif